/usr/share/topgit/tg-export is in topgit 0.8-1.1.
This file is owned by root:root, with mode 0o755.
The actual contents of the file can be viewed below.
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 | #!/bin/sh
# TopGit - A different patch queue manager
# (c) Petr Baudis <pasky@suse.cz> 2008
# GPLv2
name=
branches=
output=
driver=collapse
flatten=false
numbered=false
## Parse options
while [ -n "$1" ]; do
arg="$1"; shift
case "$arg" in
-b)
branches="$1"; shift;;
--flatten)
flatten=true;;
--numbered)
flatten=true;
numbered=true;;
--quilt)
driver=quilt;;
--collapse)
driver=collapse;;
--linearize)
driver=linearize;;
-*)
echo "Usage: tg [...] export ([--collapse] NEWBRANCH | [-b BRANCH1,BRANCH2...] --quilt DIRECTORY | --linearize NEWBRANCH)" >&2
exit 1;;
*)
[ -z "$output" ] || die "output already specified ($output)"
output="$arg";;
esac
done
[ -z "$branches" -o "$driver" = "quilt" ] ||
die "-b works only with the quilt driver"
[ "$driver" = "quilt" ] || ! "$numbered" ||
die "--numbered works only with the quilt driver";
[ "$driver" = "quilt" ] || ! "$flatten" ||
die "--flatten works only with the quilt driver"
if [ -z "$branches" ]; then
# this check is only needed when no branches have been passed
name="$(git symbolic-ref HEAD | sed 's#^refs/heads/##')"
base_rev="$(git rev-parse --short --verify "refs/top-bases/$name" 2>/dev/null)" ||
die "not on a TopGit-controlled branch"
fi
playground="$(mktemp -d -t tg-export.XXXXXX)"
trap 'rm -rf "$playground"' EXIT
## Collapse driver
# pretty_tree NAME
# Output tree ID of a cleaned-up tree without tg's artifacts.
pretty_tree()
{
(export GIT_INDEX_FILE="$playground/^index"
git read-tree "$1"
git update-index --force-remove ".topmsg" ".topdeps"
git write-tree)
}
create_tg_commit()
{
name="$1"
tree="$2"
parent="$3"
# Get commit message and authorship information
git cat-file blob "$name:.topmsg" | git mailinfo "$playground/^msg" /dev/null > "$playground/^info"
GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$playground/^info")"
GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$playground/^info")"
GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$playground/^info")"
SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$playground/^info")"
test -n "$GIT_AUTHOR_NAME" && export GIT_AUTHOR_NAME
test -n "$GIT_AUTHOR_EMAIL" && export GIT_AUTHOR_EMAIL
test -n "$GIT_AUTHOR_DATE" && export GIT_AUTHOR_DATE
(printf '%s\n\n' "$SUBJECT"; cat "$playground/^msg") |
git stripspace |
git commit-tree "$tree" -p "$parent"
}
# collapsed_commit NAME
# Produce a collapsed commit of branch NAME.
collapsed_commit()
{
name="$1"
rm -f "$playground/^pre" "$playground/^post"
>"$playground/^body"
# Determine parent
parent="$(cut -f 1 "$playground/$name^parents")"
if [ "$(cat "$playground/$name^parents" | wc -l)" -gt 1 ]; then
# Produce a merge commit first
parent="$({
echo "TopGit-driven merge of branches:"
echo
cut -f 2 "$playground/$name^parents"
} | git commit-tree "$(pretty_tree "refs/top-bases/$name")" \
$(for p in $parent; do echo -p $p; done))"
fi
if branch_empty "$name"; then
echo "$parent";
else
create_tg_commit "$name" "$(pretty_tree $name)" "$parent"
fi;
echo "$name" >>"$playground/^ticker"
}
# collapse
# This will collapse a single branch, using information about
# previously collapsed branches stored in $playground.
collapse()
{
if [ -s "$playground/$_dep" ]; then
# We've already seen this dep
commit="$(cat "$playground/$_dep")"
elif [ -z "$_dep_is_tgish" ]; then
# This dep is not for rewrite
commit="$(git rev-parse --verify "$_dep")"
else
# First time hitting this dep; the common case
echo "Collapsing $_dep"
commit="$(collapsed_commit "$_dep")"
mkdir -p "$playground/$(dirname "$_dep")"
echo "$commit" >"$playground/$_dep"
fi
# Propagate our work through the dependency chain
mkdir -p "$playground/$(dirname "$_name")"
echo "$commit $_dep" >>"$playground/$_name^parents"
}
## Quilt driver
quilt()
{
if [ -z "$_dep_is_tgish" ]; then
# This dep is not for rewrite
return
fi
if "$flatten"; then
bn="$(echo "$_dep.diff" | sed -e 's#_#__#g' -e 's#/#_#g')";
dn="";
else
bn="$(basename "$_dep.diff")";
dn="$(dirname "$_dep.diff")/";
if [ "x$dn" = "x./" ]; then
dn="";
fi;
fi;
if [ -e "$playground/$_dep" ]; then
# We've already seen this dep
return
fi
mkdir -p "$playground/$(dirname "$_dep")";
touch "$playground/$_dep";
if branch_empty "$_dep"; then
echo "Skip empty patch $_dep";
else
if "$numbered"; then
number="$(echo $(($(cat "$playground/^number" 2>/dev/null) + 1)))";
bn="$(printf "%04u-$bn" $number)";
echo "$number" >"$playground/^number";
fi;
echo "Exporting $_dep"
mkdir -p "$output/$dn";
$tg patch "$_dep" >"$output/$dn$bn"
echo "$dn$bn -p1" >>"$output/series"
fi
}
linearize()
{
if test ! -f "$playground/^BASE"; then
head="$(git rev-parse --verify "$_dep")"
echo "$head" > "$playground/^BASE"
git checkout -q "$head"
return;
fi;
head=$(git rev-parse --verify HEAD)
if [ -z "$_dep_is_tgish" ]; then
# merge in $_dep unless already included
rev="$(git rev-parse --verify "$_dep")";
common="$(git merge-base --all HEAD "$_dep")";
if test "$rev" = "$common"; then
# already included, just skip
:;
else
retmerge=0;
git merge -s recursive "$_dep" || retmerge="$?";
if test "x$retmerge" != "x0"; then
echo fix up the merge, commit and then exit;
#todo error handling
sh -i </dev/tty;
fi;
fi;
else
retmerge=0;
git merge-recursive "$(pretty_tree "refs/top-bases/$_dep")" -- HEAD "$(pretty_tree "refs/heads/$_dep")" || retmerge="$?";
if test "x$retmerge" != "x0"; then
git rerere;
echo "fix up the merge and update the index. Don't commit!"
#todo error handling
sh -i </dev/tty;
fi
result_tree=$(git write-tree)
# testing branch_empty might not always give the right answer.
# It can happen that the patch is non-empty but still after
# linearizing there is no change. So compare the trees.
if test "x$result_tree" = "x$(git rev-parse $head^{tree})"; then
echo "skip empty commit $_dep";
else
newcommit=$(create_tg_commit "$_dep" "$result_tree" HEAD)
git update-ref HEAD $newcommit $head
echo "exported commit $_dep";
fi
fi
}
## Machinery
if [ "$driver" = "collapse" ] || [ "$driver" = "linearize" ]; then
[ -n "$output" ] ||
die "no target branch specified"
! ref_exists "$output" ||
die "target branch '$output' already exists; first run: git branch -D $output"
elif [ "$driver" = "quilt" ]; then
[ -n "$output" ] ||
die "no target directory specified"
[ ! -e "$output" ] ||
die "target directory already exists: $output"
mkdir -p "$output"
fi
driver()
{
case $_dep in refs/remotes/*) return;; esac
branch_needs_update >/dev/null
[ "$_ret" -eq 0 ] ||
die "cancelling export of $_dep (-> $_name): branch not up-to-date"
$driver
}
# Call driver on all the branches - this will happen
# in topological order.
if [ -z "$branches" ]; then
recurse_deps driver "$name"
(_ret=0; _dep="$name"; _name=""; _dep_is_tgish=1; driver)
else
echo "$branches" | tr ',' '\n' | while read _dep; do
_dep_is_tgish=1
$driver
done
name="$(echo "$branches" | sed 's/.*,//')"
fi
if [ "$driver" = "collapse" ]; then
git update-ref "refs/heads/$output" "$(cat "$playground/$name")" ""
depcount="$(cat "$playground/^ticker" | wc -l)"
echo "Exported topic branch $name (total $depcount topics) to branch $output"
elif [ "$driver" = "quilt" ]; then
depcount="$(cat "$output/series" | wc -l)"
echo "Exported topic branch $name (total $depcount topics) to directory $output"
elif [ "$driver" = "linearize" ]; then
git checkout -q -b $output
echo $name
if test $(git rev-parse "$(pretty_tree $name)^{tree}") != $(git rev-parse "HEAD^{tree}"); then
echo "Warning: Exported result doesn't match";
echo "tg-head=$(git rev-parse "$name"), exported=$(git rev-parse "HEAD")";
#git diff $head HEAD;
fi;
fi
# vim:noet
|